
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Attendance_sessionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const attendance_sessions = await db.attendance_sessions.create(
            {
                id: data.id || undefined,
        
        session_date: data.session_date
        ||
        null
            ,
            
        session_type: data.session_type
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await attendance_sessions.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await attendance_sessions.setCampus( data.campus || null, {
            transaction,
        });
        
        await attendance_sessions.setClass( data.class || null, {
            transaction,
        });
        
        await attendance_sessions.setClass_subject( data.class_subject || null, {
            transaction,
        });
        
        await attendance_sessions.setTaken_by( data.taken_by || null, {
            transaction,
        });
        

        

        

        return attendance_sessions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const attendance_sessionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                session_date: item.session_date
            ||
            null
            ,
            
                session_type: item.session_type
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const attendance_sessions = await db.attendance_sessions.bulkCreate(attendance_sessionsData, { transaction });

        // For each item created, replace relation files
        

        return attendance_sessions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const attendance_sessions = await db.attendance_sessions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.session_date !== undefined) updatePayload.session_date = data.session_date;
        
        
        if (data.session_type !== undefined) updatePayload.session_type = data.session_type;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await attendance_sessions.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await attendance_sessions.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.campus !== undefined) {
            await attendance_sessions.setCampus(
              
              data.campus,
              
              { transaction }
            );
        }
        
        if (data.class !== undefined) {
            await attendance_sessions.setClass(
              
              data.class,
              
              { transaction }
            );
        }
        
        if (data.class_subject !== undefined) {
            await attendance_sessions.setClass_subject(
              
              data.class_subject,
              
              { transaction }
            );
        }
        
        if (data.taken_by !== undefined) {
            await attendance_sessions.setTaken_by(
              
              data.taken_by,
              
              { transaction }
            );
        }
        

        
        

        

        return attendance_sessions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const attendance_sessions = await db.attendance_sessions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of attendance_sessions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of attendance_sessions) {
                await record.destroy({transaction});
            }
        });


        return attendance_sessions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const attendance_sessions = await db.attendance_sessions.findByPk(id, options);

        await attendance_sessions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await attendance_sessions.destroy({
            transaction
        });

        return attendance_sessions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const attendance_sessions = await db.attendance_sessions.findOne(
            { where },
            { transaction },
        );

        if (!attendance_sessions) {
            return attendance_sessions;
        }

        const output = attendance_sessions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.attendance_records_attendance_session = await attendance_sessions.getAttendance_records_attendance_session({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await attendance_sessions.getOrganization({
            transaction
        });
        
        
        output.campus = await attendance_sessions.getCampus({
            transaction
        });
        
        
        output.class = await attendance_sessions.getClass({
            transaction
        });
        
        
        output.class_subject = await attendance_sessions.getClass_subject({
            transaction
        });
        
        
        output.taken_by = await attendance_sessions.getTaken_by({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.campuses,
        as: 'campus',
        
        where: filter.campus ? {
          [Op.or]: [
            { id: { [Op.in]: filter.campus.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.campus.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.classes,
        as: 'class',
        
        where: filter.class ? {
          [Op.or]: [
            { id: { [Op.in]: filter.class.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.class.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.class_subjects,
        as: 'class_subject',
        
        where: filter.class_subject ? {
          [Op.or]: [
            { id: { [Op.in]: filter.class_subject.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.class_subject.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.staff,
        as: 'taken_by',
        
        where: filter.taken_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.taken_by.split('|').map(term => Utils.uuid(term)) } },
            {
              employee_number: {
                [Op.or]: filter.taken_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'attendance_sessions',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.session_dateRange) {
                const [start, end] = filter.session_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    session_date: {
                    ...where.session_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    session_date: {
                    ...where.session_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.session_type) {
                where = {
                    ...where,
                session_type: filter.session_type,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.attendance_sessions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'attendance_sessions',
                        'session_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.attendance_sessions.findAll({
            attributes: [ 'id', 'session_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['session_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.session_type,
        }));
    }

    
};

